<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
      <el-form-item label="用户ID" prop="configId">
        <el-input
          v-model="queryParams.configId"
          placeholder="请输入用户ID"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="邮件标题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入邮件标题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['setting:emailtpl:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['setting:emailtpl:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['setting:emailtpl:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['setting:emailtpl:export']"
        >导出</el-button>
      </el-col>
    </el-row>

    <el-table
      v-loading="loading"
      :data="emailtplList"
      :default-sort="{prop: 'createTime', order: 'descending'}"
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="主键ID" align="center" prop="id" /> -->
      <el-table-column label="序号" type="index" align="center" width="50" />
      <el-table-column label="用户ID" align="center" sortable="custom" prop="configId" />
      <el-table-column label="消息类型" align="center" sortable="custom" prop="messageType">
        <template slot-scope="scope">
          <span>{{dictValueToLabel(scope.row.messageType, newsTypeOptions)}}</span>
        </template>
      </el-table-column>
      <el-table-column label="邮件标题" align="center" prop="title" />
      <el-table-column label="创建时间" sortable="custom" align="left" prop="createTime" width="160">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, "{y}-{m}-{d} {h}:{i}:{s}") }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['setting:emailtpl:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['setting:emailtpl:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改邮件模板对话框 -->
    <el-dialog class="form-dialog" :title="title" :visible.sync="open" width="680px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="邮件用户" prop="configId">
          <el-select v-model="form.configId" placeholder="请选择邮件用户">
            <el-option
              v-for="item in emailList"
              :key="item.id"
              :label="item.account"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="消息类型" prop="messageType">
          <el-select v-model="form.messageType" placeholder="请选择消息类型">
            <el-option
              v-for="dict in newsTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="邮件标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入邮件标题" />
        </el-form-item>
        <el-form-item label="模板内容" class="editor-item" prop="templateContent">
          <!-- <el-input   用富文本编辑器
            v-model="form.templateContent"
            placeholder="请输入模板内容"
          />-->
          <f-editor class="f-editor" :value="form.templateContent" @input="editor_event" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listEmailtpl,
  getEmailtpl,
  delEmailtpl,
  addEmailtpl,
  updateEmailtpl
} from "@/api/setting/emailtpl";
import { listEmail } from "@/api/setting/email";
import { dictValueToLabel } from "@/utils/hciot";
import Editor from "@/components/Editor/index.vue";

export default {
  name: "Emailtpl",
  components: {
    fEditor: Editor
  },
  props: {
    tenantId: {
      type: Number,
      default: null
    }
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 邮件用户
      emailList: [],
      // 非单个禁用
      newsTypeOptions: [],
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 邮件模板表格数据
      emailtplList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        configId: undefined,
        title: undefined,
        orderByColumn: "createTime",
        isAsc: "desc"
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        configId: [
          { required: true, message: "邮件用户不能为空", trigger: "blur" }
        ],
        title: [
          { required: true, message: "邮件标题不能为空", trigger: "blur" }
        ],
        templateContent: [
          { required: true, message: "模板内容不能为空", trigger: "blur" }
        ],
        messageType: [
          { required: true, message: "消息类型不能为空", trigger: "blur" }
        ]
      }
    };
  },
  created() {
    this.getList();
    this.init();
  },
  methods: {
    dictValueToLabel,
    sortChange(column) {
      const sort = {
        isAsc: column.order === "descending" ? "desc" : "asc",
        orderByColumn: column.prop
      };
      this.queryParams = Object.assign(this.queryParams, sort);
      this.handleQuery();
    },
    // 富文本编辑器回调方法。
    editor_event(data) {
      this.form.templateContent = data;
    },
    // 默认初始化 方法
    init() {
      this.getDicts("sms_news_type").then(response => {
        this.newsTypeOptions = response.data;
      });
    },
    /** 查询邮件模板列表 */
    getList() {
      this.loading = true;
      listEmailtpl(
        Object.assign(
          {
            tenantId: this.tenantId
          },
          this.queryParams
        )
      ).then(response => {
        this.emailtplList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询短信厂商列表 */
    getEmailList() {
      listEmail({ tenantId: this.tenantId }).then(response => {
        this.emailList = response.rows;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        configId: undefined,
        messageType: undefined,
        title: undefined,
        templateContent: undefined,
        tenantId: this.tenantId
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getEmailList();
      this.open = true;
      this.title = "添加邮件模板";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getEmailList();
      const id = row.id || this.ids;
      getEmailtpl(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改邮件模板";
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != undefined) {
            updateEmailtpl(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addEmailtpl(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(
        // '是否确认删除邮件模板编号为"' + ids + '"的数据项?',
        "是否删除该数据",
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }
      )
        .then(function() {
          return delEmailtpl(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "setting/emailtpl/export",
        {
          ...this.queryParams
        },
        `setting_emailtpl.xlsx`
      );
    }
  }
};
</script>
<style lang="scss" scoped>
.f-editor {
  width: 100%;
  height: 260px;
  position: relative;
  top: 50px;
  left: -40px;
}
</style>

